//+------------------------------------------------------------------+
//|                                                   AV_2Orders.mq4 |
//|                        Copyright 2016-2020, TRADEXPERTS StatBars |
//|                                           https://tradexperts.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016-2020, TRADEXPERTS StatBars"
#property link      "https://tradexperts.ru"
#property version   "1.00"
#property strict

extern int TP = 20;
extern int SL = 10;
extern double lot = 0.1;
extern int Magic_Number = 45546635;
extern int slippage = 1;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   bool res;
   int t;
   
   if( Orders_Total_by_type( OP_BUY, Magic_Number,Symbol()) == 0
   && Orders_Total_by_type( OP_SELL, Magic_Number,Symbol()) == 0 )
   {
      if( IsTradeAllowed() )
      {
         t = OrderSend( Symbol(), OP_BUY, lot, Ask, slippage, NormalizeDouble( Bid - SL*Point, Digits), NormalizeDouble( Ask + TP*Point, Digits), "", Magic_Number, 0, clrBlue);
         if( t > 0 )
         {
            RefreshRates();
            t = OrderSend( Symbol(), OP_SELL, lot, Bid, slippage, NormalizeDouble( Ask + SL*Point, Digits), NormalizeDouble( Bid - TP*Point, Digits), "", Magic_Number, 0, clrRed);
            if( t<= 0 )
            {
               RefreshRates();
               t = OrderSend( Symbol(), OP_SELL, lot, Bid, slippage, NormalizeDouble( Ask + SL*Point, Digits), NormalizeDouble( Bid - TP*Point, Digits), "", Magic_Number, 0, clrRed);
            }
         }
      }
   }
   
   if( Orders_Total_by_type( OP_BUY, Magic_Number,Symbol()) == 1
   && Orders_Total_by_type( OP_SELL, Magic_Number,Symbol()) == 0 )
   {
      for( int i = OrdersTotal()-1; i >= 0; i-- )
      {
         res = OrderSelect( i, SELECT_BY_POS, MODE_TRADES);
         if( res && OrderMagicNumber() == Magic_Number && OrderSymbol() == Symbol() && OrderType() == OP_BUY )
         {
            if( Bid - MarketInfo( Symbol(), MODE_STOPLEVEL)*Point > OrderOpenPrice() )
               OrderModify( OrderTicket(), OrderOpenPrice(), OrderOpenPrice(), OrderTakeProfit(), OrderExpiration(), clrLime);
         }
      }
   }
   if( Orders_Total_by_type( OP_BUY, Magic_Number,Symbol()) == 0
   && Orders_Total_by_type( OP_SELL, Magic_Number,Symbol()) == 1 )
   {
      for( int i = OrdersTotal()-1; i >= 0; i-- )
      {
         res = OrderSelect( i, SELECT_BY_POS, MODE_TRADES);
         if( res && OrderMagicNumber() == Magic_Number && OrderSymbol() == Symbol() && OrderType() == OP_SELL )
         {
            if( Ask + MarketInfo( Symbol(), MODE_STOPLEVEL)*Point < OrderOpenPrice() )
            OrderModify( OrderTicket(), OrderOpenPrice(), OrderOpenPrice(), OrderTakeProfit(), OrderExpiration(), clrLime);
         }
      }
   }
//----   
}
//+------------------------------------------------------------------+


int Orders_Total_by_type(int type,int mn,string sym)
{
   int num_orders=0;
   bool res;
   for(int i=OrdersTotal()-1;i>=0;i--)
   {
      res = OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderMagicNumber()==mn && type==OrderType() && sym==OrderSymbol())
         num_orders++;
   }
   return(num_orders);
}
